commit 1ec79bfaaa9fc97b4867e96a4501c94df240a7b0
Author: freddy77 <freddy77>
Date:   Thu Jan 28 13:15:20 2010 +0000

    does not overwrite error with other calls

diff --git a/ChangeLog b/ChangeLog
index 8746c61..4b2ee45 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,6 @@
+Thu Jan 28 14:14:04 CET 2010    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* src/tds/net.c: does not overwrite error with other calls
+
 Thu Jan 28 11:06:05 CET 2010    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/tds/sspi.c: remove wrong TODO comment
 
@@ -2248,4 +2251,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog-0.82 added because of release
 	
 $FreeTDS$
-$Id: ChangeLog,v 1.2971 2010/01/28 10:07:18 freddy77 Exp $
+$Id: ChangeLog,v 1.2972 2010/01/28 13:15:20 freddy77 Exp $
diff --git a/src/tds/net.c b/src/tds/net.c
index 2b2a226..f1f1b76 100644
--- a/src/tds/net.c
+++ b/src/tds/net.c
@@ -107,7 +107,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: net.c,v 1.100 2010/01/10 14:43:12 freddy77 Exp $");
+TDS_RCSID(var, "$Id: net.c,v 1.101 2010/01/28 13:15:21 freddy77 Exp $");
 
 #undef USE_POLL
 #if defined(HAVE_POLL_H) && defined(HAVE_POLL) && !defined(C_INTERIX)
@@ -273,10 +273,10 @@ tds_open_socket(TDSSOCKET * tds, const char *ip_addr, unsigned int port, int tim
 	if (retval == 0) {
 		tdsdump_log(TDS_DBG_INFO2, "connection established\n");
 	} else {
-		tds->oserr = sock_errno;
-		tdsdump_log(TDS_DBG_ERROR, "tds_open_socket: connect(2) returned \"%s\"\n", sock_strerror(sock_errno));
+		int err = tds->oserr = sock_errno;
+		tdsdump_log(TDS_DBG_ERROR, "tds_open_socket: connect(2) returned \"%s\"\n", sock_strerror(err));
 #if DEBUGGING_CONNECTING_PROBLEM
-		if (sock_errno != ECONNREFUSED && sock_errno != ENETUNREACH && sock_errno != TDSSOCK_EINPROGRESS) {
+		if (err != ECONNREFUSED && err != ENETUNREACH && err != TDSSOCK_EINPROGRESS) {
 			tdsdump_dump_buf(TDS_DBG_ERROR, "Contents of sockaddr_in", &sin, sizeof(sin));
 			tdsdump_log(TDS_DBG_ERROR, 	" sockaddr_in:\t"
 							      "%s = %x\n" 
@@ -290,7 +290,7 @@ tds_open_socket(TDSSOCKET * tds, const char *ip_addr, unsigned int port, int tim
 							);
 		}
 #endif
-		if (sock_errno != TDSSOCK_EINPROGRESS)
+		if (err != TDSSOCK_EINPROGRESS)
 			goto not_available;
 		
 		if (tds_select(tds, TDSSELWRITE|TDSSELERR, timeout) <= 0) {
@@ -691,6 +691,7 @@ tds_goodwrite(TDSSOCKET * tds, const unsigned char *buffer, size_t len, unsigned
 
 	while (p - buffer < len) {
 		if ((rc = tds_select(tds, TDSSELWRITE, tds->query_timeout)) > 0) {
+			int err;
 			size_t remaining = len - (p - buffer);
 #ifdef USE_MSGMORE
 			ssize_t nput = send(tds->s, p, remaining, last ? MSG_NOSIGNAL : MSG_NOSIGNAL|MSG_MORE);
@@ -704,22 +705,24 @@ tds_goodwrite(TDSSOCKET * tds, const unsigned char *buffer, size_t len, unsigned
 				p += nput;
 				continue;
 			}
-			
-			if (0 == nput || TDSSOCK_WOULDBLOCK(sock_errno))
+
+			err = sock_errno;
+			if (0 == nput || TDSSOCK_WOULDBLOCK(err))
 				continue;
 
 			assert(nput < 0);
-			
-			tdsdump_log(TDS_DBG_NETWORK, "send(2) failed: %d (%s)\n", sock_errno, sock_strerror(sock_errno));
-			tdserror(tds->tds_ctx, tds, TDSEWRIT, sock_errno);
+
+			tdsdump_log(TDS_DBG_NETWORK, "send(2) failed: %d (%s)\n", err, sock_strerror(err));
+			tdserror(tds->tds_ctx, tds, TDSEWRIT, err);
 			tds_close_socket(tds);
 			return -1;
 
 		} else if (rc < 0) {
-			if (TDSSOCK_WOULDBLOCK(sock_errno)) /* shouldn't happen, but OK, retry */
+			int err = sock_errno;
+			if (TDSSOCK_WOULDBLOCK(err)) /* shouldn't happen, but OK, retry */
 				continue;
-			tdsdump_log(TDS_DBG_NETWORK, "select(2) failed: %d (%s)\n", sock_errno, sock_strerror(sock_errno));
-			tdserror(tds->tds_ctx, tds, TDSEWRIT, sock_errno);
+			tdsdump_log(TDS_DBG_NETWORK, "select(2) failed: %d (%s)\n", err, sock_strerror(err));
+			tdserror(tds->tds_ctx, tds, TDSEWRIT, err);
 			tds_close_socket(tds);
 			return -1;
 		} else { /* timeout */

